/***************************************************************************
 *
 * CRI Middleware SDK
 *
 * Copyright (c) 2001-2004 CRI-MW
 *
 * Appli.   : ADXT Sample Program 
 * Module   : Main function.(MFS / Memory File System Sample)
 * File     : adxmfs.c
 *
 ***************************************************************************/

/***************************************************************************
 *      インクルードファイル
 *      Include file
 ***************************************************************************/
#include <stdio.h>

#include <cri_mw.h>
#include <cri_ut.h>
#include "usr/usr.h"

/***************************************************************************
 *      定数マクロ
 *      Process MACRO
 ***************************************************************************/
/*	最大チャンネル数				*/
/*	The number of maximum channels	*/
#define	MAX_CH		(2)

/*	同時再生最大CDストリーム数									*/
/*	The number of maximum CD streams playing at the same time	*/
#define	MAX_CDSTM	(1)

/*	最高サンプリング周波数		*/
/*	Maximum sampling frequency	*/
#define	MAX_SFREQ	(48000)

/*	ファイル再生用ワーク領域の大きさ	*/
/*	Work area size of CD stream play	*/
#define WKSIZE		ADXT_CALC_WORK(MAX_CH, ADXT_PLY_STM, MAX_CDSTM, MAX_SFREQ)

/***************************************************************************
 *      処理マクロ
 *      Process MACRO
 ***************************************************************************/
/*	フラグON/OFFの反転		*/
/*	Turn over flag(ON/OFF)	*/
#define NOT_FLAG(flag)		(((flag) == OFF) ? ON : OFF)

#define UNUSED(val)			((val) = (val))

/***************************************************************************
 *      変数定義
 *		Variable Declaration
 ***************************************************************************/
/*	アプリケーション構造体											*/
/*	Application structure											*/
typedef struct {
	Sint32	disp_flag;			//	Display information flag
	Char8	*fname;				//	File name
	ADXT 	adxt;				//	ADXT handle
	Char8	mfname[256];
	Uint8	*buf;
	Uint8	*ptr;
	Sint32	fsize;
	Sint8 	wk[WKSIZE];			//	Work area
} AP_OBJ;

/*	アプリケーションオブジェクト									*/
/*	Application Object												*/
AP_OBJ ap_obj = {
	ON,							//	Sint32	disp_flag;
	"voice48a.adx",				//	ADX file name
	NULL						//	ADXT handle
};

/***************************************************************************
 *      関数宣言
 *      Prototype Function 
 ***************************************************************************/
void ap_adx_err_func(void *obj, Char8 *msg);
void ap_disp_info(AP_OBJ *ap);
void ApInitMw(AP_OBJ *ap);
void ApFinishMw(AP_OBJ *ap);
void ApStart(AP_OBJ *ap);
void ApStop(AP_OBJ *ap);
Sint32 ApExec(AP_OBJ *ap);

void ap_create_mem_file(AP_OBJ *ap);

/***************************************************************************
 *      関数定義
 *      Function Declaration
 ***************************************************************************/

/*	ADXTエラー発生時に起動する関数					*/
/*	Callback function when an error occur in ADXT	*/
void ap_adx_err_func(void *obj, Char8 *msg)
{
	UNUSED(obj);		// 未使用変数

	UsrDbgPrintf(msg);

	for (;;) {		/*	リリース時には無くす					*/
		;			/*	Delete when you release application.	*/
	}
}

void ap_create_mem_file(AP_OBJ *ap)
{
	ADXF	adxf=NULL;
	Sint32	fnsct;

	if ((adxf = ADXF_Open(ap->fname, NULL)) == NULL) {
		for (;;) ;
	}
	fnsct = ADXF_GetFsizeSct(adxf);
	ap->fsize = fnsct * 2048;
	if ((ap->buf = (Uint8 *)UsrMalloc((Uint32)ap->fsize+64)) == NULL) {
		for (;;) ;
	}

	ap->ptr = (Uint8 *)(((UintPtr)(ap->buf) + 63) & 0xffffffc0);
	
	ADXF_ReadNw(adxf, fnsct, ap->ptr);
	while (ADXF_GetStat(adxf) != ADXF_STAT_READEND) {
		ADXM_ExecMain();		
		ADXM_WaitVsync();
	}
	
	ADXF_Close(adxf);
	sprintf(ap->mfname, "MFS:%08x.%08x", (UintPtr)ap->ptr, ap->fsize);
}

/*	ミドルウェアの初期化				*/
/*	Initialize Middleware				*/
void ApInitMw(AP_OBJ *ap)
{
	UNUSED(ap);	// 未使用変数

	/*	ADXライブラリ初期化		*/
	/*	Initialize ADX library	*/
	ADXT_Init();
}

/*	ミドルウェアの終了					*/
/*	Finalize Middleware					*/
void ApFinishMw(AP_OBJ *ap)
{
	UNUSED(ap);	// 未使用変数

	ADXT_Finish();
}

/*	アプリケーション開始処理	*/
/*	Start application			*/
void ApStart(AP_OBJ *ap)
{
	ap->adxt	= NULL;

	/*	ADXT ハンドルの生成	*/
	/*	Create ADXT handle	*/
	ap->adxt = ADXT_Create(2, ap->wk, WKSIZE);
	if (ap->adxt == NULL) {
		printf("can't create ADXT \n");
		for (;;) ;
	}

	ap_create_mem_file(ap);

	/*	再生開始		*/
	/*	Start to play	*/
	ADXT_StartFname(ap->adxt, ap->mfname);
}

/*	アプリケーション停止処理	*/
/*	Stop application			*/
void ApStop(AP_OBJ *ap)
{
	UsrFree(ap->buf);
	ap->buf = NULL;

	/*	ADXT ハンドルの消去	*/
	/*	Destroy ADXT handle	*/
	ADXT_Destroy(ap->adxt);
	ap->adxt = NULL; 
}

/*	情報の表示			*/
/*	Display infomation	*/
void ap_disp_info(AP_OBJ *ap)
{
	char 		*ststr[] =
		{"STOP   ", "DECINFO", "PREP   ", "PLAYING", "DECEND ", "PLAYEND"};
	Sint32		stat, sfreq, cnt;
	Sint32		hh, mm, ss, ff;
	
	UsrPrintf(3, 3, "ADX Sample Program");
	UsrPrintf(3, 4, "   ADX Playing Memory-Stream");

	stat = ADXT_GetStat(ap->adxt);

	UsrPrintf(3,  6, "FILE = %s", ap->fname);
	UsrPrintf(3,  7, "STAT = %s (%d)", ststr[stat], stat);
	ADXT_GetTime(ap->adxt, &cnt, &sfreq);
	UsrSfcnt2time(sfreq,  cnt, &hh, &mm, &ss, &ff);
	UsrPrintf(3,  8, "TIME = %2d:%02d:%02d.%02d", hh, mm, ss, ff);
}

/*	アプリケーションメイン処理	*/
/*	Run application				*/
Sint32 ApExec(AP_OBJ *ap)
{
	const USR_PERIPHERAL	*per;

	per = UsrGetPeripheral(0);	
	if (per->press & UTPAD_L) {
		ap->disp_flag = NOT_FLAG(ap->disp_flag);
	}
	if (per->press & UTPAD_BUTTON1) {
		return FALSE;
	}

	if (ap->disp_flag == ON) {
		ap_disp_info(ap);
	}

	if (ADXT_GetStat(ap->adxt) == ADXT_STAT_PLAYEND) {
		return FALSE;
	}

	ADXM_ExecMain();	

	return TRUE;
}

/***
 *		メイン処理
 *		MAIN
 ***/
int main(void)
{
	AP_OBJ	*ap;
	Sint32	term_flag = OFF;
	Bool	ret;

	ap = &ap_obj;

	/*	エラーコールバック関数の登録		*/
	/*	Entry ADX error callback function	*/
	ADXM_SetCbErr(ap_adx_err_func, NULL);
	
	/*	システムの初期化										*/
	/*	Initialize System										*/
	UsrInitSystem(NULL, NULL);
	
	/*	ビデオの初期化											*/
	/*	Initialize Video System									*/
	UsrInitVideo(NULL, NULL);
	
	/*	サウンドの初期化										*/
	/*	Initialize Sound System									*/
	UsrInitSound(NULL, NULL);

	ApInitMw(ap);

	while (term_flag == OFF) {
		ApStart(ap);
		/*	cnt :frame count						*/
		/*	cnt=0:interlace	/ cnt>0:non interlace	*/
		UsrInitSync(2);
		
		for (;;) {
			UsrSyncFrame();
			UsrBeginDraw();
			ret = ApExec(ap);
			UsrEndDraw();

			/* 終了するかどうかの確認					*/
			/* Checks whether Usr module is terminated	*/
			if (UsrIsTerminated() == TRUE) {
				term_flag = ON;
			}
			
			if (ret == FALSE || term_flag == ON) {
				break;
			}
		}
		
		ApStop(ap);
	}
	/*	アプリケーション終了処理	*/
	/*	Finalize application		*/
	ApFinishMw(ap);			/*	ミドルウェアの終了				*/
							/*	Finalize Middleware				*/
	UsrFinishSound();		/*	サウンドシステムの終了処理		*/
							/*	Finalize sound system			*/
	UsrFinishVideo();		/*	ビデオの終了処理				*/
							/*	Finalize Video system			*/
	UsrFinishSystem();		/*	システムの終了処理				*/
							/*	Finalize system					*/
	return 0;
}
